
import javax.swing.*;

/**
 * Clase que contiene los componentes del menu
 * 
 * @version 0.19
 * @author Linus Casassa B. & Javier Gonzalez O.
 */
public class MenuBar extends JMenuBar {

    public MenuBar(Lista lista_izq, Lista lista_der) {

        MenuBarEvents events = new MenuBarEvents(lista_izq, lista_der);
        JMenu menu = null;
        JMenuItem menuItem = null;

        // Archivo -> Abrir Archivo
        //         -> Salir
        menu = new JMenu("Archivo");
        menuItem = new JMenuItem("Abrir Archivo");
        menuItem.addActionListener(events);
        menu.add(menuItem);
        menuItem = new JMenuItem("Salir");
        menuItem.addActionListener(events);
        menu.add(menuItem);
        add(menu);

        // Accion -> Rodar
        //         -> Buscar
        menu = new JMenu("Accion");
        menuItem = new JMenuItem("Rodar");
        menuItem.addActionListener(events);
        menu.add(menuItem);
        menuItem = new JMenuItem("Buscar");
        menuItem.addActionListener(events);
        menu.add(menuItem);
        add(menu);

        //menu de ayuda a la derecha
        add(Box.createHorizontalGlue());
        JMenu menuAyuda = new JMenu("Ayuda");
        menuItem = new JMenuItem("Acerca de");
        menuItem.addActionListener(events);
        menuAyuda.add(menuItem);
        add(menuAyuda);

    }
}
