
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.Random;
import java.util.ArrayList;
import java.util.NoSuchElementException;

/**
 * clase que contiene las acciones a realizar por los actionListener
 * 
 * @version 0.19
 * @author Linus Casassa B. & Javier Gonzalez O.
 */
public class MenuBarEvents implements ActionListener, MenuListener {

    private Lista lista_izq = null;
    private Lista lista_der = null;

    public MenuBarEvents(Lista lista_izq, Lista lista_der) {
        this.lista_der = lista_der;
        this.lista_izq = lista_izq;
    }

    public void actionPerformed(ActionEvent e) {

//		if (cPanel==null) return;

        if (e.getActionCommand().equals("Abrir Archivo")) {
            //System.out.println("Abrir Archivo");
            JFileChooser chooser = new JFileChooser(".");
            TXTFileFilter filter = new TXTFileFilter();
            chooser.setFileFilter(filter);
            int returnVal = chooser.showOpenDialog(null);
            if (returnVal == JFileChooser.APPROVE_OPTION) {
                System.out.println("You chose to open this file: " +
                        chooser.getSelectedFile().getPath());

                FileExtractor extractor = new FileExtractor(chooser.getSelectedFile().getPath());

                lista_izq.clear();
                try {
                    while (extractor.quedanNombres()) {
                        lista_izq.add(extractor.getRealName());
                    }
                } catch (NoSuchElementException excepcion) {
                    System.err.println("Por favor elija un archivo que contenga una lista de alumnos.");
                    JOptionPane.showMessageDialog(null, "Por favor elija un " +
                            "archivo que contega una lista de alumnos.", "Lista de Alumnos",
                            JOptionPane.WARNING_MESSAGE);

                }
            }
        }

        if (e.getActionCommand().equals("Salir")) {
            System.out.println("Salida del programa");
            System.exit(0);
//            salida del programa tambien por menu

        }

        if (e.getActionCommand().equals("Rodar")) {
            try {
                System.out.println("Rodar");

                if (lista_izq.get(0) == "Porfavor abra un archivo.") {
                    JOptionPane.showMessageDialog(null, "Porfavor abra un archivo bajo Archivo -> Abrir.", "Warning", JOptionPane.WARNING_MESSAGE);
                    return;
                }


                int size = lista_izq.getSize();
                String[] tmp = new String[size];

                for (int i = 0; i < size; i++) {
                    tmp[i] = lista_izq.get(i);
                }

                lista_der.clear();

                Random rand = new Random();

                for (int i = 0; i < size; i++) {
                    int numero = rand.nextInt(size - i);
                    lista_der.add(tmp[numero]);
                    if (numero != size - i) {
                        //System.out.println("tmp[" + numero + "] = tmp[" + size + "-" + i + "]");
                        tmp[numero] = tmp[(size - 1) - i];
                    }
                }

            } catch (Exception exc) {
                System.err.println("Para poder rodar elija un archivo que contenga una lista de alumnos.");
                JOptionPane.showMessageDialog(null, "Para poder rodar elija un " +
                        "archivo que contega una lista de alumnos.", "Lista de Alumnos",
                        JOptionPane.WARNING_MESSAGE);
            }
        }

        if (e.getActionCommand().equals("Buscar")) {

            System.out.println("Buscar");

            if (lista_der.get(0) == "Accion -> Rodar") {
                JOptionPane.showMessageDialog(null, "Porfavor abra un archivo bajo Archivo -> Abrir y luego vaya a Accion -> Rodar para que hayan datos en la lista derecha.", "Warning", JOptionPane.WARNING_MESSAGE);
                return;
            }

            String inputValue = JOptionPane.showInputDialog("A quien desea buscar?");
            //System.out.println("Porfavor busca a \"" + inputValue + "\". Gracias");

            int size = lista_der.getSize();
            ArrayList<Integer> seleccion = new ArrayList<Integer>();

            lista_der.clearSelect();
            for (int i = 0; i < size; i++) {
                String s = new String(lista_der.get(i));
                if (s.contains(inputValue)) {
                    seleccion.add(new Integer(i));
                }
            }

            lista_der.select(seleccion);

        }

        if (e.getActionCommand().equals("Acerca de")) {
            JOptionPane.showMessageDialog(null, "Trabajo realizado por: " +
                    "\nLinus Casassa B.\nJavier Gonzalez O.\n" +
                    "\nProfesor: Agustin Gonzalez V.\n" +
                    "Fecha: 28 de Mayo de 2008",
                    "Acerca de: Tarea 2 - ELO329",
                    JOptionPane.INFORMATION_MESSAGE);
        }

    /*		if (e.getActionCommand().equals("Salir")){
    String input = JOptionPane.showInputDialog("Valor ?");
    int v = Integer.parseInt(input);
    }
     */
    }

    public void menuSelected(MenuEvent me) {
        //throw new UnsupportedOperationException("Not supported yet.");
    }
//    public void menuSelected(MenuEvent e) {
//        JOptionPane.showMessageDialog(null, "Linus Casassa Tarea 2", "About Titulo", 1);
////		System.out.println("About");
//    }
    public void menuCanceled(MenuEvent me) {
    }

    public void menuDeselected(MenuEvent me) {
    }
}
